unit Radio;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Controls, Graphics, Forms, LCLIntf;

type
  TClickEvent = procedure(Sender: TObject) of object;

type
  { TRadio }

  TRadio = class(TCustomControl)
  private
    FCaption  : TCaption;
    FChecked  : boolean;
    FGroup    : integer;
    FHotspot  : TRect;
    FOnClick  : TClickEvent;
    procedure SetCaption(AValue: TCaption);
    procedure SetChecked(AValue: boolean);
    procedure CheckTheGroup;
  public
    constructor Create(AOwner: TComponent); override;
    procedure  Paint; override;
    procedure MouseDown({%H-}Button: TMouseButton;{%H-}Shift: TShiftState; X, Y: Integer);override;

    property Caption : TCaption    read FCaption  write SetCaption;
    property Checked : boolean     read FChecked  write SetChecked;
    property Group   : integer     read FGroup    write FGroup;
    property OnClick : TClickEvent read FOnClick  write FOnClick;
  end;




implementation

{ TRadio }

procedure TRadio.SetChecked(AValue: boolean);
begin
  if FChecked=AValue then Exit;
  FChecked:=AValue;
  invalidate;
  CheckTheGroup;
end;

procedure TRadio.SetCaption(AValue: TCaption);
begin
  if FCaption=AValue then Exit;
  FCaption:=AValue;
  invalidate;
end;

procedure TRadio.CheckTheGroup;
var comp        : TComponent;
    CurRadio    : TRadio;
    CurForm     : TForm;
    CurControl  : TControl;
    lv          : integer;
    exitflag    : boolean;
begin
 lv:=0; exitflag := false;
 CurControl := Parent;
 repeat
  if CurControl is TForm then exitflag := true
   else
    CurControl := CurControl.Parent;      //back to the Form
  inc(lv);
 until (lv =100) or (exitflag = true);

 CurForm := (CurControl as TForm);
 for comp in CurForm do
        begin
         if comp is TRadio then
           begin
            CurRadio := comp as TRadio;
            if CurRadio.Group = FGroup then
             begin
              if CurRadio <> self then
               begin
                CurRadio.FChecked:= false;
                CurRadio.invalidate;
               end;//<>self
             end;//Group
            end;//comp is
         end;//comp in

end;

constructor TRadio.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width                    := 120;
  Height                   :=  20;
  FGroup                   :=   0;
  FCaption                 := 'Radiobutton';
  FHotspot                 := rect(0,0,width,height);
end;

procedure TRadio.Paint;
begin
  inherited Paint;
  canvas.Brush.Color  := clWhite;
  canvas.FillRect(0,0,width,height);

  canvas.Pen.Color    := clBlack;
  canvas.Pen.Width    := 2;
  canvas.Ellipse(2,2,20,18);
  canvas.TextOut(25,2,FCaption);

  if checked then
   begin
    canvas.Pen.Color   := clRed;
    canvas.Brush.Color := clRed;
    canvas.Ellipse(8,7,14,13);
   end;
end;

procedure TRadio.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if PtInRect(FHotspot,Point(x,y)) then
   begin
    Checked:=true;
    if Assigned(OnClick) then OnClick(self);
   end;
end;

end.

